<?php

namespace go\modules\business\fileconverter;

use go\core;
use go\modules\business\fileconverter\model\Settings;
use go\modules\business\fileconverter\service\IService;

/**
 * Class Module
 * @package go\modules\business\onlyoffice
 */
class Module extends core\Module
{
	public static function getTitle()
	{
		return 'File convertor';
	}

	public static function getDescription()
	{
		return 'Adds a save to PDF and download as PDF option to the files module for Word, Power point and Open Document text files.';
	}

	public function requiredLicense()
	{
		return 'groupoffice-pro';
	}

	public function getAuthor()
    {
        return 'Michal Charvat <info@michalcharvat.cz>';
    }

    public function depends()
    {
        return array('files');
    }

    /**
     * @return core\Settings|Settings|null
     */
    public function getSettings()
    {
        return Settings::get();
    }

    /**
     * @return IService
     */
    public static function getAvailableService()
    {
        $serviceType = Settings::get()->serviceType;
        if (empty($serviceType)) {
            throw new \RuntimeException('Missing module configuration - serviceType');
        }

        $serviceClass = __NAMESPACE__ . '\\service\\' . ucfirst($serviceType);
        if (!class_exists($serviceClass)) {
            throw new \RuntimeException('Service class is not available ' . $serviceClass);
        }

        return new $serviceClass;
    }
}