<?php


namespace GO\Timeregistration2;


use go\core\model\User;
use go\core\orm\Mapping;
use go\core\orm\Property;

class Timeregistration2Module extends \GO\Professional\Module {

	public function depends() {
		return array('projects2');
	}

    public function defineListeners() {
        User::on(Property::EVENT_MAPPING, static::class, 'onMap');
    }

    public static function onMap(Mapping $mapping) {
        $mapping->addHasOne('timeRegistrationSettings', \GO\Timeregistration2\Model\UserSettings::class, ['id' => 'userId'], true);
    }

	/**
	 * The module settings
	 * @var \GO\Projects2\Model\Settings
	 * @see getSettings()
	 */
	private $_settings;

	public function getSettings() {
		if (!isset($this->_settings))
			$this->_settings = \GO\Projects2\Model\Settings::load();
		return $this->_settings;
	}

	public function autoInstall() {
		return true;
	}

}
